let wrapper = `
<g transform="rotate(90)">
  {turnt}
</g>
`.trim();

let inner = `
<g clip-path="url(#clip)" transform="rotate({neg}90) scale(0.5 1) translate(-1)">
  <use href="#gate" transform="scale({scale}) translate({trans})" />
  {first_delayed}
  {second_delayed}
</g>
`.trim();

let svg = `
<svg xmlns="http://www.w3.org/2000/svg" fill="none" stroke="#000" viewBox="-1 -1 2 2">
  <defs>
    <rect id="outline-box" x="-1" y="-1" width="2" height="2" vector-effect="non-scaling-stroke" />

    <clipPath id="clip">
      <rect x="-1" y="-1" width="2" height="2" />
    </clipPath>

    <g id="gate" transform="scale(0.25)">
      <line x1="-256" y1="0" x2="-0.5" y2="0" vector-effect="non-scaling-stroke" />
      <line x1="0.5" y1="0" x2="256" y2="0" vector-effect="non-scaling-stroke" />
    </g>
  </defs>
  <g>
    <!-- transforms happen in order -->
    <use href="#outline-box" />
    <g clip-path="url(#clip)">
      <!-- edit rotation here to rotate whole maze -->
      <g id="5s" transform="rotate(90)">
        <!-- main line, translate to move gap (0 +-0.9) -->
        <use href="#gate" transform="scale({scale}) translate({trans})" />
        {first}
        {second}
      </g>
    </g>

  </g>

</svg>
`.trim();

let f_inner = inner.replace("{neg}", "");
let s_inner = inner.replace("{neg}", "-");

for (let i = 0; i < 7; i++) {
  svg = svg.replaceAll("{scale}", String(Math.pow(2, i) / 8));
  svg = svg.replaceAll("{second}", "{tmp}");
  svg = svg.replaceAll("{first}", f_inner);
  svg = svg.replaceAll("{tmp}", s_inner);
  while (svg.includes("{trans}")) {
    svg = svg.replace("{trans}", String(Math.random() * 0.2));
  }
  while (svg.includes("{first}") || svg.includes("{second}")) {
    if (Math.random() > 0.5) {
      svg = svg.replace("{first}", wrapper);
      svg = svg.replace("{turnt}", "{first}");
    }
    if (Math.random() > 0.5) {
      svg = svg.replace("{second}", wrapper);
      svg = svg.replace("{turnt}", "{second}");
    }
    svg = svg.replace("{first}", f_inner);
    svg = svg.replace("{second}", s_inner);
  }
  svg = svg.replaceAll("_delayed}", "}");
}

let i = 7;
svg = svg.replaceAll("{scale}", String(Math.pow(2, i) / 8));

svg = svg.replaceAll("{first}", "");
svg = svg.replaceAll("{second}", "");
svg = svg.replaceAll("{neg}", "");
svg = svg.replaceAll("{scale}", "");
svg = svg.replaceAll("{turnt}", "");
svg = svg.replaceAll("{trans}", "");
svg = svg.replaceAll("{first_delayed}", "");
svg = svg.replaceAll("{second_delayed}", "");

console.log(svg);
